<?php
/*
Code rcupr et modifi  partir du plugin tabledata
//=====================================================================
// PLUGIN - TABLE DATA - V0.40
//                                         CONTRIBUTION POUR SPIP 1.9.1
// 19 fv 2007                          Christophe BOUTIN - Opalys.info
//=====================================================================

Il commence  tre franchement mconnaissable... mais bon :-)

 */

//gestion de la prsentation des cl primaires sous une forme
//comprhensible par un humain
$GLOBALS['auto_form']['plugins'][] = '';
$GLOBALS['auto_form']['plugins'][] = 'gopaypal_';
 
function mbt_echo_form_table($table_mysql, 
                            $serveur='', 
                            $idLigne='', 
                            $prop_champs = array(), //details sur des champs dcrits qui hrite par ce paramtre d'une particularit
                                                    //l'entree _PLUGIN_ de ce tableau permet d'aller chercher des traductions pour les labels des champs
                            $echo_pk = true)        //est ce que l'on affiche les cls primaires ou pas ?
{
//pour la gestion de l'initialisation des champs par JS.
//un peu gadget, mais ceux qui font de la saisie apprieront
static $racine_id = 'eztezarteza';
static $cpt_id = 0;

    $nom_plugin = isset( $prop_champs['_PLUGIN_'] )?$prop_champs['_PLUGIN_']:'';

    include_spip('base/abstract_sql');
    $abstract = spip_abstract_showtable($table_mysql, $serveur);
    $fields = $abstract['field'];
    $keys   = $abstract['key'];

    $ligne = null;
    if ( $idLigne != '' ) {
        $pk = $keys['PRIMARY KEY'];
        $requete = "SELECT * FROM $table_mysql WHERE $pk='$idLigne'";
        $result  = spip_query($requete);
        $ligne   = spip_fetch_array($result, SPIP_NUM);
    }

    $total    = '<table>';
    $cptLigne = -1;
    foreach ($fields as $k => $v) {
        ++$cptLigne;
        
        if ( isset($prop_champs[$k]) ) {
            if ( $prop_champs[$k] == 0 )
                continue;
        }
        
        ereg("^ *([A-Za-z]+) *(\(([^)]+)\))?(.*default *'(.*)')?", $v, $m);
        $type = strtoupper($m[1]);
        $initScript = '';
        $s = ($m[5] ? " value='$m[5]' " : '');
        $d = ( isset($prop_champs[$k]['size']) )?" size='{$prop_champs[$k]['size']}' ":" size='60' ";
        $t = $m[3];
        if ($m[2]) {
            if (is_numeric($t)) {
                if ($t <= 32)
                    $d = " sizemax='$t' size='" . ($t * 2) . "'";
                else
                    $type = 'BLOB';
            }
            else {
                ereg("^ *'?(.*[^'])'? *$", $t, $m2); $t = $m2[1];
            }
        }
        
        $pk = '';
        if (array_search($k, $keys) == "PRIMARY KEY") {
            if ( !$echo_pk )
                continue;
            $pk  = '(*)';
            if ( $type != 'VARCHAR')
                $d .= " readonly='readonly' ";
        }
        
        switch ( $type ) {
            case INT:
            case SMALLINT:
            case INTEGER:
            case BIGINT:
            case CHAR:
            case VARCHAR:
                if ( (strpos($k, 'id_')) === 0 && ($pk == '') ) {
                    foreach ($GLOBALS['auto_form']['plugins'] as $plugin) {
                        $nom_table = 'spip_' . $plugin . substr($k, 3) .'s';
                        $abstract = spip_abstract_showtable($nom_table);
                        if ( isset($abstract['field']) ) {
                            $order = '';
                            $what = array();
                            if ( isset($GLOBALS['auto_form']['pk-h'][$nom_table]) ) {
                                $what = $GLOBALS['auto_form']['pk-h'][$nom_table];
                                $order = " ORDER BY $what";
                                $what = explode(',', $what);
                            }
                            $requete = "SELECT * FROM $nom_table $order";
                            $result  = spip_query($requete);
                            $select = "<option value='0'>0</option>";
                            while ( $ligneLoc = spip_fetch_array($result) ) {
                                $selected = '';
                                if ( $ligne && ($ligne[$cptLigne] == $ligneLoc[$k]) ) {
                                    $selected = " selected='selected' ";
                                }
                                $pk_h = '';
                                foreach ($what as $cle) {
                                    $pk_h .= $ligneLoc[$cle].' ';
                                }
                                $pk_h .= "({$ligneLoc[$k]})";
                                $select .= "<option value='{$ligneLoc[$k]}' $selected>$pk_h</option>";
                            }
                            $s = "<td><select name='$k'>$select</select></td>";
                            break 2;
                        }
                    }
                }
            case TINYTEXT:
            case TINYBLOB:
            CASE FLOAT:
                if ( $ligne ) {
                    $s = " value='{$ligne[$cptLigne]}' ";
                }
                $s = "<td><input type='text'$s $d name='$k' /></td>\n";
                break;
            CASE TINYINT:
            CASE BOOL:
            CASE BOOLEAN:
                $selected_1 = '';
                if ( $ligne && $ligne[$cptLigne] == 1 ) {
                    $selected_1 = " selected='selected' ";
                }
                $s = "<td><select name='$k'>".
                          "<option value='0'>0</option>".
                          "<option value='1' $selected_1>1</option>".
                          "</select></td>";
                break;
            case ENUM:
                $s = "<td><select name='$k'>\n";
                foreach (split("'? *, *'?",$t) as $v) {
                    $c = '';
                    if ( $ligne ) {
                        if ( $v == $ligne[$cptLigne] )
                            $c = " selected='selected' ";
                    }
                    $s .= "<option $c >$v</option>\n";
                }
                $s .= "</select></td>\n";
                break;
            case DATETIME:
                $s = '';
                $hiddens .= "<input type='hidden' name='$k' value='NOW()'/>\n";
                break;
            case TIMESTAMP:
                $s = '';
                break;
            case LONGBLOB:
                $s = $m[5];
                if ( $ligne ) {
                    $s = $ligne[$cptLigne];
                }
                $s = "<td><textarea name='$k' cols='40' rows='20'>$s</textarea></td>\n";
                break;
            default:
                $s = $m[5];
                if ( $ligne ) {
                    $s = $ligne[$cptLigne];
                }
                $t = floor($t / 40) + 3;
                $id = $racine_id.($cpt_id++);
                $s = "<td><textarea name='$k' cols='40' rows='$t' id='$id'>$s</textarea></td>\n";
                $initScript = "<a href=\"javascript:intialiser_text('$id');\">/i/</a>";
                break;
        }
        if ($s) {
            $label = '';
            if ( $nom_plugin ) {
                $label = _T($nom_plugin . ':' . $k);
            }
            $label = ( $label )?$label:$k;
            $total .= "<tr><td>$label $pk $initScript</td>\n$s</tr>\n";
        }
    }
    $total .= '</table>';
    
    return $hiddens.$total;
}

function mbt_maj_table_depuis_form($table_mysql, $options = null) {
$bavard       = isset($options['bavard'])?$options['bavard']:false;
$action       = isset($options['action'])?$options['action']:'';     //creer, maj ou supprimer
$confirmation = isset($options['confirmation'])?$options['confirmation']:false;
$apercu       = isset($_REQUEST['apercu'])?true:false;

    include_spip('base/abstract_sql');
    $abstract = spip_abstract_showtable($table_mysql, $serveur);
    $fields = $abstract['field'];
    $keys   = $abstract['key'];
    
    $pks    = explode(',', $keys['PRIMARY KEY']);
    foreach ( $pks as $k => $v) {
        $pks[$k] = trim($v);
    }
    $keys['PRIMARY KEY'] = implode(',', $pks);
    
    if ( $action == '' && isset($_REQUEST['action']) )
        $action = $_REQUEST['action'];
    
    $requete = 'sql';
   
    switch ( $action ) {
        case 'ajouter':
            $action = 'creer';
        case 'creer':
            $fieldsList = '';
            $valuesList = '';
            foreach ($fields as $k => $v) {
                if ( $v == 'TIMESTAMP' )
                    continue;
                if ( !isset($_REQUEST[$k]) )
                    continue;
                if ( in_array($k, $pks) ) {
                    //if ( strpos(strtoupper($v), 'VARCHAR') === null ) { // cas de la cl primaire qui n'est pas auto incrmente
                    //    continue;
                    //}
                }
                $fieldsList .= $virg.$k;
                $valuesList .= $virg.'"'.$_REQUEST[$k].'"';
                $virg = ',';
            }
            $requete = "INSERT INTO $table_mysql ($fieldsList) VALUES ($valuesList)";
            break;
        case 'maj':
            $requete = "UPDATE $table_mysql SET ";
            $virg = '';
            foreach ($fields as $k => $v) {
                if ( $v == 'TIMESTAMP')
                    continue;
                $requete .= $virg." ".$k."=\"".$_REQUEST[$k]."\"";
                $virg = ',';
            }
            $requete .= " WHERE ";
            $and = '';
            foreach ( $pks as $pk ) {
                if ( isset($_REQUEST[$pk]) ) {
                    $requete .= $and."($pk='".$_REQUEST[$pk]."')";
                    $and = ' and ';
                }
                else {
                    $requete = 'cl&eacute; primaire incomplete !';
                    break;
                }
            }
            break;
        case 'supprimer':
            if ( $confirmation ||isset($_REQUEST['confirmation']) ) {
                if ( !is_array($_REQUEST['r_pks']) ) 
                    $_REQUEST['r_pks'] = array($_REQUEST['r_pks']);
                foreach ($_REQUEST['r_pks'] as $r_pk) {
                    $r_pk = explode(',', $r_pk);
                    $requete = "DELETE FROM $table_mysql WHERE ";
                    $and = '';
                    $i = 0;
                    foreach ( $pks as $pk ) {
                        if ( isset($r_pk[$i]) ) {
                            $requete .= $and."($pk='{$r_pk[$i++]}')";
                            $and = ' and ';
                        }
                        else {
                            $requete = 'cl&eacute; primaire incomplete !';
                            break;
                        }
                    }
                    if ( !$apercu )
                        spip_query($requete);
                }
            }
            else {
                $requete = "suppression non confirm&eacute; !";
            }
            break;
        default :
            return;
    }
    
    if ( $bavard ) {
        echo debut_boite_info();
        echo htmlentities($requete);
        echo fin_boite_info();
    }
    
    if ( !$apercu ) {
        spip_query($requete);
        if ( $action == 'creer' ) {
            if ( !isset($_REQUEST[$pks[0]]) || $_REQUEST[$pks[0]] == '' ) {
                $_REQUEST[$pks[0]] = mysql_insert_id();
            }
        }
    }
}

?>